#include "ko_match.h"
#include "option_parser.h"

int getFileSize(char *filename)
{
	int filesize;
	struct stat buf;

	if(stat(filename, &buf) < 0) {
		exit(-1);
	}
	filesize = buf.st_size;

	return filesize;
}

/* convert a file into a binary stream */
unsigned char *binaryReadFile(char *filename, int filesize)
{
	unsigned char *binaryCode;
	int curr, idx_1, idx_2;
	unsigned char buffer[1];
	FILE *file;

	binaryCode = malloc(filesize * sizeof(unsigned char) * 8);

	file = fopen(filename, "r");
	
	for (idx_1 = 0; idx_1 < filesize; idx_1++)
	{
		curr =0;
		buffer[0] = 0;
		fread(buffer, 1, 1, file);

		curr = (int)buffer[0];

		/* create the binary code */
		for (idx_2 = 0; idx_2 < 8; idx_2++)
		{
			binaryCode[idx_1 * 8 + 7 - idx_2] = curr % 2;
			curr /= 2;
		}
	}
	
	fclose(file);
	return binaryCode;
}

int main(int argc, char **argv)
{
	Options options;
	int size, idx, lHd = 0;
	unsigned char *irisCode_1;
	unsigned char *irisCode_2;

	/* get the command line parameters */
	options = parseOptions(argc, argv);

	size = getFileSize(options.input_1);

	irisCode_1 = binaryReadFile(options.input_1, size);
	irisCode_2 = binaryReadFile(options.input_2, size);

	printf("Matching '%s' and '%s'\n", options.input_1, options.input_2);
	/* calculate lower Hamming distance */
	for (idx = 0; idx < size*8; idx ++)
	{
		if (irisCode_1[idx] == 1 && irisCode_2[(idx+(size*8)/2)%(size*8)] == 1)
		{
			lHd+=1^2;
		}
	}
	
	/* write the result to a file */
	printf("Lower Hamming distance: %d\n", lHd);
	
	free(irisCode_1);
	free(irisCode_2);

	return 0;
}
