#include "option_parser.h"

/* print the correct usage of the program */
void printUsage()
{
	printf("[-f] [-s]\n\n");

	printf(" -f\tINPUT_1\n");
	printf(" -s\tINPUT_2\n");
}

/* create an 'Options' struct out of the cmd parameters */
Options parseOptions(int argc, char **argv)
{
	int opt, nrOfArguments;
	Options options;
	
	nrOfArguments = 0;

	/* no parameters given */
	if( argc == 1 )
	{
		printUsage();
		exit(1);
	}

	/* get all the parameters */
	while( (opt = getopt(argc, argv, "f:s:h:") ) != -1 )
	{
		switch(opt)
		{
			case 'h':
				printUsage();
				exit(0);;
			case 'f':
				strcpy(options.input_1, optarg);
				nrOfArguments++;
				break;
			case 's':
				strcpy(options.input_2, optarg);
				nrOfArguments++;
				break;
			case '?':
				printUsage();
				exit(1);
		}
	}

	/* not enough parameters given */
	if ( nrOfArguments != NR_OF_ARGUMENTS )
	{
		printUsage();
		exit(1);
	}
	return options;
}
